/* common functions from http://ir2.ru/ir2.js */

function addLoadEvent(func) {
 var oldonload = window.onload;
 if (typeof window.onload != 'function') {
  window.onload = func;
 }
 else {
  window.onload = function() {
   oldonload();
   func();
  }
 }
}
function _hasClass(classN /*string only*/, c) {
 if (!c || !classN) return false
 return (" " + classN + " ").indexOf(" " + c + " ") !== -1
}

function changeClass(obj, c, type) {
 if (!c) return false
 var classN = ("string" == typeof obj) ? obj : obj.className
 var re = new RegExp('(\\s+|^)' + ("string" == typeof c ? c : (c && c[1])) + '(\\s+|$)', 'g')
 switch (type) {
  case 2: /*addClass*/
   if (!_hasClass(classN, c)) classN += " " + c
   else return false
   break
  case 3: /*delClass*/
   if (_hasClass(classN, c)) classN = classN.replace(re, " ")
   else return false
   break
  case 4: /*replaceClass*/
   if (!(1 in c)) return false
   else classN = classN.replace(re, " ") + " " + c[0]
   break
  default:
   return false
   break
 }
 if ("object" == typeof obj) obj.className = classN 
 else return classN
}

function findChild(obj, tag, classn, rec) {
 if (!obj) return null
 if (!obj.hasChildNodes()) return null
 var objtag //=obj.tagName !!! 16:04 13.09.2010
 var el, el_class, list = (rec) ? obj.getElementsByTagName(tag) : obj.childNodes
 var l = list.length
 for (var i=0; i<l; i++) {
  el = list[i]
  objtag = el.tagName
  el_class = el.className
  if (objtag && tag.toLowerCase()==objtag.toLowerCase() 
   && (!classn || _hasClass(el_class, classn))) {
   return el
   break
  }
 }
 return null
}

function findParent(obj, tag, classn){ 
 var objtag
 if (typeof(tag) == "object" && null!=tag) {
  while (obj && document.body!=obj.parentNode) {
   obj=obj.parentNode
   if (obj==tag) return obj
  }
  return null
 }
 while (obj && document.body!=obj.parentNode) {
  obj=obj.parentNode //  !!
  objtag=obj && obj.tagName
  if (objtag && tag.toLowerCase()==objtag.toLowerCase()) {
   if (!classn || -1!=obj.className.indexOf(classn)) {
    return obj
   }
  }
 }
 return null
}

function getCookie(name) {
 var value=new RegExp("(^|;)\\s*"+name+"\\s*\\=\\s*([^;]+)($|;)","i").exec(unescape(document.cookie));
 return value && value[2];
}

function setCookie(name, value, path, time) {
 path = (path) ? "; path=" + path : ""
 var expires = new Date()
 if (isNaN(time)) expires = ""
 else {
  if (time < 0) time = -(12*60*60*1000)
  else if (time === 0) time = 36*24*60*60*1000
  expires.setTime(expires.getTime()+time)
  expires = expires.toGMTString()
  expires = "; expires=" + expires
 }
 name=("string"==typeof(name) && name) || this.name || this.id
 value = (undefined == value) ? this.value : value
 value=(this.type && "checkbox"==this.type && "on"==value)?1:value
 value=(this.type && "select-one"==this.type)?this.selectedIndex:value
 
 document.cookie = escape(name) + "=" + escape(value) + expires + path
}

function prevent(e) {
 e.cancelBubble = true
 if (e.stopPropagation) {
  e.stopPropagation()
  e.preventDefault()
 }
}

function deselect(obj) {
 obj = obj || document.body
 if (obj.createTextRange) {
  var r = obj.createTextRange()
  r.collapse(true)
  r.select()
 }
 else if (window.getSelection) {
  window.getSelection().collapse(obj, 0)
 }
}

function stripTags(str) {
 str=str.replace(/\<[^\<\>]+\>/ig,"");
 return str;
}

function getTopLeft(elem) {
 var top=0, left=0
 while(elem) {
  top = top + parseInt(elem.offsetTop)
  left = left + parseInt(elem.offsetLeft)
  elem = elem.offsetParent
 }
 return {top:top, left:left}
}

function trim(str) {
 var newstr = str.replace(/\&nbsp\;/g,"\xa0");
 newstr = newstr.replace(/^\s+|\s+$/,"");
 return newstr;
}

/* common functions end */

(function () { /* HTML  */
 if (!window.global) global = {}

 /*  */
 dec = (1/2).toString().replace(/\d/g, "")
 undigit = new RegExp("[^\\d\\" + dec + "]+", "g")
  /*    : */
 sort_table_class = "sortable"
 sort_table_vis_class = "sortable_vis"
  /*  "" (   CSS): */
 invis_class = "disnone"
  /*  ,    : */
 result_class = "abstopleft"
  /*     ( tabsort.css): */
 arrow_color = 1
  /*    : */
 arrow_unsort = "c_0_c"
 page_size = 20
 data_type_patt = new RegExp("^(num|ip|datru|daten|formula)$")
 w_pick = null //   ()
 /*   */

 var msg = document.createElement("DIV")
 msg.className = "tablog"
 msg.innerHTML = "&bull; : ESC. &bull; "
 global.msg = msg

 var navig = document.createElement("p")
 navig.className = "navig"
 navig.innerHTML = '<button onclick="move(-1,true); return false;" title=" (Ctrl + Alt + &larr;)"><span>&lt;&lt;</span></button>\
  <button onclick="move(-1); return false;" title=" (Ctrl + &larr;)"><span>&lt;</span></button>\
  <span> </span><span class=\'pagenum\'></span>  <span class=\'pageall\'></span> \
  <button onclick="move(1); return false;" title=" (Ctrl + &rarr;)"><span>&gt;</span></button>\
  <button onclick="move(1,true); return false;" title=" (Ctrl + Alt + &rarr;)"><span>&gt;&gt;</span></button>\
  <span>  <input class="page_size" onkeyup="page_size = parseInt(this.value)">  </span>\
  <button class="set" onclick="page(); return false;"><span></span></button> \
  &bull; <a href="#" onclick="clearHist(); return false;">   </a>\
  '
 global.navig = navig

 var seek_form = document.createElement("p")
 seek_form.className = "navig"
 seek_form.innerHTML = '\
  <button onclick="seek(true); return false;" class="x"><span>x</span></button> \
  <input class="seekval" name="seekval"> \
  <button onclick="seek(); return false;" class="find"><span>   </span></button> (<span class=\'mainfield\'></span>)\
  <button onclick="dataSeek(); return false;" class="find"><span>  </span></button> (<span class=\'fulltxtfield\'></span>)\
  '
 global.seek_form = seek_form

 var inputs_el = document.createElement("DIV")
 var input_el = document.createElement("DIV")
 changeClass(inputs_el, 'inputs', 2)
 changeClass(input_el, 'inputs', 2)
 inputs_el.innerHTML = "<span class='absle'>&ge;</span><input class='num' onkeyup='dataFilter(this, 1)'></div><div class='inputs'><span class='absle'>&le;</span><input class='num' onkeyup='dataFilter(this, 2)'>"
 input_el.innerHTML = "<input class='str' onkeyup='dataFilter(this, 3)'>"
 global.inputs_el = inputs_el
 global.input_el = input_el

 var arrows_el = document.createElement("DIV")
 arrows_el.innerHTML = "<div class='up'></div><div class='down'></div>"
 changeClass(arrows_el, 'arrows only', 2)
 global.arrows_el = arrows_el

 var i = 1, html = '<img src="img/c1.gif">',
  img_loader = document.createElement('DIV')
 for (i; i < 11; i++) {
  html += '<img src="img/d' + i + '.gif"><img src="img/u' + i + '.gif">'
 }
 changeClass(img_loader, invis_class, 2)
 img_loader.innerHTML = html
 global.img_loader = img_loader

 /*  -    */
 var bull = document.createElement("DIV")
 bull.className = "bull"
 bull.innerHTML = "&bull;"
 global.bull = bull

  /*     */
 var result = document.createElement("SPAN")
 result.className = result_class
 changeClass(result, invis_class, 2)
 global.result = result

})()

function initBoxes(classN, vis) {
 var arr = window[classN]
 if (!arr || typeof arr != 'object') return
 var i = 0, ii, comma, st = getCookie(classN), 
  checked, htm = '', boxes = document.createElement('DIV')
// if (st === null) st = Math.pow(2, 20) - 1
 for (var name in arr) {
  comma = (0 === i) ? '<span>' : ', </span> <span>'
  arr[name] = (st === null) ? arr[name] : !!(Math.pow(2, i) & Number(st))
  checked = (arr[name] === true) ? " checked='checked'" : ""
  htm += comma + name + ':<input onclick="setDef(this, \'' + classN + '\')" type="checkbox" name="' + name + '"' + checked + '">'
//  if (i==0) alert((Number(st) + "//" + name + "//" + i + "//" + (Math.pow(2, i) & Number(st))), "", true)
  if (!arr[name]) work(classN, name, false)
  i++
 }
 boxes.className = classN
 boxes.innerHTML = htm + "</span>"
 return (vis) ? boxes : null
}

function setDef(obj, classN) {
 var i = 0, ii = 0, n = obj.name, st = obj.checked, arr = window[classN]
// addLog(n, "", true)
 arr[n] = st
 for (var name in arr) {
  if (arr[name] === true) ii += Math.pow(2, i)
  i++
 }
 setCookie(classN, ii, "", 0)
 work(classN, n, st)
}

function work(classN, n, st) {
 var table = global.last_table
 var i = /^(\d+)/.exec(n)
 if ((i && i[1]) === null) return
 i = i[1]
 if (classN == "col_names") {
  var col = findChild(table, "colgroup").getElementsByTagName("col")[i]
  var wcol = col.offsetWidth, ccol = col.className
  var wtab = table.offsetWidth
  if (st) {
   table.style.width = (wtab + wcol)
   col.className = col.oldClass || ""
  }
  else {
   col.oldWidth = wcol
   col.oldClass = ccol
   col.className = "wcol0"
   table.style.width = (wtab - wcol)
  }
 }
}

function pickHref(e) {
 e = e || window.event;
 if (!e.ctrlKey || !e.altKey) return
 prevent(e);
 var obj = e.target || e.srcElement,
  table = findParent(obj, "table"), a, html, td, tr
 if (obj.tagName && obj.tagName == "A")
  a = obj
 else a = findParent(obj, "A")
 if (!a) a = findChild(obj, "A")
 td = findParent(obj, "td")
 tr = findParent(obj, "tr")
 if (!tr) return

 if (!w_pick || w_pick.closed) {
  window.w_pick=window.open();
  var w = 400, h = 600;
  w_pick.resizeTo(w, h);
  w_pick.moveTo(screen.width-w, 0);
  w_pick.document.write("<html><head><title> </title>\
  <script type='text/javascript'>\
function selectAll(target) {\
 target = (target && target.nodeType == 1) ? target : document.body;\
 var rng, sel;\
 if(document.createRange){\
  rng = document.createRange();\
  rng.selectNodeContents(target);\
  sel = window.getSelection();\
  sel.removeAllRanges();\
  sel.addRange(rng);\
 }\
 else{\
  rng = document.body.createTextRange();\
  rng.moveToElementText(target);\
  rng.select();\
 }\
}\
</script>\
</head><body><p><button onclick='selectAll(document.body.lastChild)'> </button></p><pre onclick='return false'>");
  w_pick.document.close();
 }

 if (a) html = "<a href='" + a.href + "'>" + a.innerHTML + "</a><br>" + a.href + "<br><hr><br>"
 else if (table && table.fulltxt_name && table.idx_name) {
  html = tr.cells[table.idx].innerHTML + "<br>" + tr.cells[table.fulltxt].innerHTML + "<br><hr><br>"
 }
 else {
  html = "<table><tr>"
  var l = tr.cells.length
  for (var i = 0; i < l; i ++) {
   html += "<td>" + tr.cells[i].innerHTML + "</td>"
  }
  html += "</tr></table>"
 }

 w_pick.document.body.lastChild.innerHTML += html
 w_pick.opener.focus();
 return false
}

function colNames(t) {
 var names = [], i = 0, j = 0, cols = "", row = findChild(t, "colgroup"),
  col, thead = t.tHead, thead = thead && thead.rows, thl = thead.length, 
  rname, fin_arr = {}, cols = row && row.getElementsByTagName("col")
 if (!cols) return null
 var l = cols.length
 for (i; i < thl; i++) {
  rnames = thead[i].cells
  rl = rnames.length
  j = 0
  for (j; j < rl; j++) {
   names[j] = trim(stripTags(rnames[j] && rnames[j].innerHTML)) || ""
  }
 }
 for (i = 0; i < l; i++) {
  fin_arr[i + "_" + names[i]] = true
 }
/* var tx = ""
 for (var i in fin_arr) tx += ", " + i
 alert(tx)
*/
 return fin_arr
}

/*
function bukvy() {
 var bukva = {" ":"01", ".":"02", "-":"03", "":"04", "":"05", "":"06", "":"07", "":"08", "":"09", "":"10", "":"11", "":"12", "":"13", "":"14", "":"15", "":"16", "":"17", "":"18", "":"19", "":"20", "":"21", "":"22", "":"23", "":"24", "":"25", "":"26", "":"27", "":"28", "":"29", "":"30", "":"31", "":"32", "":"33", "":"34", "":"35", "":"36", "'":"37"}
}

function getTableKey() {
  return global.last_table.idx_name
}
*/
